SystemOrganization addCategory: #'SqueakNxt-Model'!
SystemOrganization addCategory: #'SqueakNxt-Constants'!
SystemOrganization addCategory: #'SqueakNxt-Errors'!
SystemOrganization addCategory: #'SqueakNxt-CommMode'!
SystemOrganization addCategory: #'SqueakNxt-DC-NxtErrors'!
SystemOrganization addCategory: #'SqueakNxt-DC'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-Model'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-Player'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-Bars'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-ControlPanel'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-Ports'!
SystemOrganization addCategory: #'SqueakNxt-Etoys-Wiring'!

Morph subclass: #ControlPanelMorph
	instanceVariableNames: 'display main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-ControlPanel'!

!ControlPanelMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 16:04'!
on: aLegoNxtMorph 
^self basicNew setMain: aLegoNxtMorph; initialize! !

!ControlPanelMorph methodsFor: 'event handling' stamp: 'Richo 10/6/2008 18:55'!
cancelClick
	^ display cancelClick! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:54'!
initialize
	super initialize.
	self
		color: (Color
				r: 0.936
				g: 0.936
				b: 0.936);
		 borderColor: Color black;
		 borderWidth: 2;
		 height: 260;
		 width: 200.
	self initializeSubmorphs! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:46'!
initializeCancelButton
	| cancelButton |
	cancelButton := NxtButtonMorph cancelButton.
	cancelButton center: self center x @ (self center y + (cancelButton height * 2));
		
		on: #mouseDown
		send: #cancelClick
		to: self.
	self addMorph: cancelButton! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 2/16/2009 16:06'!
initializeDisplay
	display := NxtDisplayMorph on: main.
	display center: self center x @ (self center y - (display height // 1.5)).
	self addMorph: display! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:46'!
initializeLeftButton
	| leftButton |
	leftButton := NxtButtonMorph leftButton.
	leftButton center: self center x - leftButton height @ (self center y + (leftButton height // 2));
		
		on: #mouseDown
		send: #leftClick
		to: self.
	self addMorph: leftButton! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:46'!
initializeOkButton
	| okButton |
	okButton := NxtButtonMorph okButton.
	okButton center: self center x @ (self center y + (okButton height // 2));
		
		on: #mouseDown
		send: #okClick
		to: self.
	self addMorph: okButton! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:47'!
initializeRightButton
	| rightButton |
	rightButton := NxtButtonMorph rightButton.
	rightButton center: self center x + rightButton height @ (self center y + (rightButton height // 2));
		
		on: #mouseDown
		send: #rightClick
		to: self.
	self addMorph: rightButton! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:54'!
initializeString
	| string |
	string := 'Squeak NXT' asMorph fontName: 'Accuat' size: 18.
	string left: self left + 10;
		 bottom: self bottom - 5.
	self addMorph: string! !

!ControlPanelMorph methodsFor: 'initialize-release' stamp: 'Richo 10/2/2008 16:44'!
initializeSubmorphs
	self initializeOkButton;initializeCancelButton;initializeLeftButton;initializeRightButton;initializeDisplay;initializeString
	! !

!ControlPanelMorph methodsFor: 'event handling' stamp: 'Richo 10/6/2008 18:54'!
leftClick
	^ display leftClick! !

!ControlPanelMorph methodsFor: 'event handling' stamp: 'Richo 10/6/2008 18:54'!
okClick
	^ display okClick! !

!ControlPanelMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 17:44'!
portName: aSymbol
display portName: aSymbol! !

!ControlPanelMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/11/2009 16:34'!
resetDisplay
display resetSubmorphs
! !

!ControlPanelMorph methodsFor: 'event handling' stamp: 'Richo 10/6/2008 18:54'!
rightClick
	^ display rightClick! !

!ControlPanelMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 16:05'!
setMain: aLegoNxtMorph 
main := aLegoNxtMorph! !

Morph subclass: #NxtDisplayMorph
	instanceVariableNames: 'portIndex portNumber main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-ControlPanel'!

!NxtDisplayMorph class methodsFor: 'constants' stamp: 'Richo 10/7/2008 18:27'!
maximumPortNumber
^10! !

!NxtDisplayMorph class methodsFor: 'constants' stamp: 'Richo 10/7/2008 18:29'!
minimumPortNumber
	^ 1! !

!NxtDisplayMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 16:06'!
on: aLegoNxtMorph
^self basicNew setMain: aLegoNxtMorph; initialize! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 17:17'!
cancelClick
	main disconnect.
	self resetSubmorphs! !

!NxtDisplayMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 18:00'!
currentPortName
"Si no lo encuentra, devuelvo el que tiene seteado main. En caso de ser cero no lo va a encontrar porque significa que el puerto lo escribi el usuario"
^self portNames at: portIndex ifAbsent: [main portName]! !

!NxtDisplayMorph methodsFor: 'initialize-release' stamp: 'Richo 10/6/2008 18:58'!
deleteSubmorphs
	self
		submorphsDo: [:each | each delete]! !

!NxtDisplayMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 17:22'!
initialize
	super initialize.
	self extent: 135 @ 80;
		
		color: (Color
				r: 0.823
				g: 0.948
				b: 0.63);
		 borderWidth: 3;
		 borderColor: Color black.
	portIndex := 1.
	self initializeSubmorphsDisconnected! !

!NxtDisplayMorph methodsFor: 'initialize disconnected' stamp: 'Richo 10/6/2008 18:46'!
initializeConnectionLabelMorph
	| s1 |
	s1 := 'Port:' asMorph fontName: 'BitstreamVeraSans' size: 18;
				 emphasis: 1;
				 center: self center.
	self addMorphBack: s1.! !

!NxtDisplayMorph methodsFor: 'initialize disconnected' stamp: 'Richo 11/10/2009 18:01'!
initializeConnectionPortNameMorph
	"Si el portIndex es cero, el puerto lo escribi el usuario. No muestro las flechitas"
	| s2 |
	s2 := self currentPortName asMorph fontName: 'BitstreamVeraSans' size: 18;
				 
				 center: self center x @ (self center y + 20).
	self addMorphBack: s2.
	portIndex = 0
		ifTrue: [^self].
	portIndex > 1
		ifTrue: [self addMorphBack: (LittleArrowMorph leftArrow center: s2 leftCenter - (10@0))].
	portIndex < self portNames size
		ifTrue: [self addMorphBack: (LittleArrowMorph rightArrow center: s2 rightCenter + (10@0))]! !

!NxtDisplayMorph methodsFor: 'initialize disconnected' stamp: 'Richo 10/6/2008 18:45'!
initializeConnectionStateMorph
	| stringMorph |
	stringMorph := '<' asMorph fontName: 'Accuat' size: 18.
	stringMorph position: self position + 5.
	self addMorphBack: stringMorph! !

!NxtDisplayMorph methodsFor: 'initialize connected' stamp: 'Richo 10/7/2008 17:14'!
initializeSubmorphsConnected
	| pl pr |
	pl := (PolygonMorph
				vertices: {0 @ -20. -20 @ 0. 0 @ 20}
				color: Color black
				borderWidth: 3
				borderColor: Color black) makeOpen center: self center;
				 right: self center x.
	pr := (PolygonMorph
				vertices: {0 @ -20. 20 @ 0. 0 @ 20}
				color: Color black
				borderWidth: 3
				borderColor: Color black) makeOpen center: self center;
				 left: self center x.
	self addMorphBack: pl;
		 addMorphBack: pr! !

!NxtDisplayMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 17:17'!
initializeSubmorphsConnected: aBoolean
aBoolean 
	ifTrue: [self initializeSubmorphsConnected]
	ifFalse: [self initializeSubmorphsDisconnected]! !

!NxtDisplayMorph methodsFor: 'initialize disconnected' stamp: 'Richo 11/10/2009 17:22'!
initializeSubmorphsDisconnected
	self initializeConnectionStateMorph.
	self initializeConnectionLabelMorph.
	self initializeConnectionPortNameMorph.! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 17:38'!
keepIndexInsideBoundaries
	portIndex >= self portNames size
		ifTrue: [portIndex := self portNames size].
	portIndex <= 1
		ifTrue: [portIndex := 1].! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 17:46'!
leftClick
	portIndex := portIndex - 1.
	self keepIndexInsideBoundaries.
	self resetSubmorphs.
	main portName: self currentPortName.! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 18:00'!
okClick
	main portName: self currentPortName; connect.
	self resetSubmorphs! !

!NxtDisplayMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 17:48'!
portName: aSymbol
portIndex := self portNames indexOf: aSymbol ifAbsent: [0].
self resetSubmorphs ! !

!NxtDisplayMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 17:15'!
portNames
^PESerialPortList availableBluetoothPorts asSet asSortedCollection.! !

!NxtDisplayMorph methodsFor: 'initialize-release' stamp: 'Richo 2/16/2009 16:07'!
resetSubmorphs
	self deleteSubmorphs.
	self initializeSubmorphsConnected:  main isConnected! !

!NxtDisplayMorph methodsFor: 'click actions' stamp: 'Richo 11/10/2009 17:46'!
rightClick
	portIndex := portIndex + 1.
	self keepIndexInsideBoundaries.
	self resetSubmorphs.
	main portName: self currentPortName.! !

!NxtDisplayMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 16:07'!
setMain: aLegoNxtMorph
main := aLegoNxtMorph! !

Morph subclass: #PortMorph
	instanceVariableNames: 'originalColor port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Ports'!

PortMorph subclass: #MotorPortMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Ports'!

!MotorPortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/15/2008 15:25'!
myDevice
^NxtMotorMorph new! !

!MotorPortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/15/2008 15:21'!
wantedDroppedMorphClasses
	"Devuelve un array con las clases que pueden conectarse a este puerto"
	^ Array with: NxtMotorMorph ! !

!MotorPortMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 12:58'!
defaultPositions
	^ ({-200 @ -100. 180 @ -250. 200 @ -100}
		collect: [:each | each + self center])
		at: port portNumber! !

!MotorPortMorph methodsFor: 'accessing' stamp: 'Richo 10/7/2008 15:19'!
letters
	^ #('A' 'B' 'C' )! !

!PortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/15/2008 15:25'!
myDevice
	"Devuelve un morph para conectarse a este puerto. En el caso de los sensores debera preguntar al usuario que tipo de sensor quiere conectar"
	^ self subclassResponsibility! !

!PortMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:46'!
port: aPort
	^ self basicNew setPort: aPort;
		 initialize! !

!PortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/15/2008 15:21'!
wantedDroppedMorphClasses
"Devuelve un array con las clases que pueden conectarse a este puerto"
^self subclassResponsibility! !

!PortMorph methodsFor: 'dropping' stamp: 'Richo 2/16/2009 16:00'!
acceptDroppingMorph: aMorph event: evt 
	"No se porqu desaparece el morph antes de llegar ac, por eso le mando
	openInWorld"
	aMorph openInWorld.
self plug: aMorph! !

!PortMorph methodsFor: 'accessing' stamp: 'Richo 10/15/2008 15:20'!
defaultPositions
"Devuelve un array con las posiciones para cada motor o sensor"
self subclassResponsibility! !

!PortMorph methodsFor: 'initializing' stamp: 'Richo 10/6/2008 16:10'!
initialize
	super initialize.
	self
		color: (Color gray mixed: 0.5 with: Color white);
		 borderColor: Color black;
		 borderWidth: 2;
		 height: 30.
	originalColor := self color.
	self
		on: #mouseEnter
		send: #mouseEnter:forMorph:
		to: self;
		
		on: #mouseLeave
		send: #mouseLeave:forMorph:
		to: self.
	self on: #mouseDown send: #mouseDown:forMorph: to: self.
	self initializeLetterMorph! !

!PortMorph methodsFor: 'initializing' stamp: 'Richo 2/16/2009 15:47'!
initializeLetterMorph
	| letterMorph |
	letterMorph := (self letters at: port portNumber) asMorph fontName: 'BitstreamVeraSans' size: 22;
				 emphasis: 1;
				 center: self center.
	self addMorph: letterMorph! !

!PortMorph methodsFor: 'accessing' stamp: 'Richo 10/10/2008 17:01'!
letters
	"Devuelve un Array de strings para cada valor de 1 a 4 (en el caso de los motores de 1 a 3)"
	self subclassResponsibility! !

!PortMorph methodsFor: 'event handling' stamp: 'Richo 2/16/2009 14:48'!
mouseDown: evt forMorph: aMorph 
	"No debera funcionar si ya tengo un motor o sensor conectado"
	self plugNewDevice! !

!PortMorph methodsFor: 'event handling' stamp: 'Richo 10/2/2008 16:37'!
mouseEnter: evt forMorph: aMorph 
	self color: originalColor muchLighter! !

!PortMorph methodsFor: 'event handling' stamp: 'Richo 10/2/2008 16:37'!
mouseLeave: evt forMorph: aMorph 
	self color: originalColor! !

!PortMorph methodsFor: 'plugging' stamp: 'Richo 11/10/2009 12:38'!
plug: aConectableDeviceMorph 
	| connector |
connector := (SqueakNxtWireMorph fromMorph: self toMorph: aConectableDeviceMorph attachmentPoint).
	aConectableDeviceMorph connector: connector.
	aConectableDeviceMorph device plugOn: port.
	aConectableDeviceMorph moveTo: self defaultPositions! !

!PortMorph methodsFor: 'plugging' stamp: 'Richo 3/5/2009 16:21'!
plugNewDevice
	| newDevice |
	port isBusy ifTrue: [^self].
	newDevice := self class myDevice.
	newDevice isNil
		ifTrue: [^ self].
	newDevice center: self center.
	newDevice openInWorld.
	self plug: newDevice! !

!PortMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 15:46'!
setPort: aPort
port := aPort! !

!PortMorph methodsFor: 'dropping' stamp: 'Richo 2/16/2009 16:00'!
wantsDroppedMorph: aMorph event: evt 
	"Slo puedo aceptar instancias que no esten conectadas. Para hacer:
	Tampoco debera
	aceptar si ya tengo algo conectado"
	^ ((self class wantedDroppedMorphClasses includes: aMorph class)
		and: [aMorph isPlugged not]) and: [port isBusy not]! !

PortMorph subclass: #SensorPortMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Ports'!

!SensorPortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:42'!
myDevice

| sensors strSensors choice |
sensors := NxtSensorMorph allSubclasses asArray.
	strSensors := sensors
				collect: [:each | '  ' , each asString , '  '].
	choice := PopUpMenu withCaption: 'Sensor:' chooseFrom: strSensors.
	choice = 0
		ifTrue: [^ nil].
	^ (sensors at: choice) new! !

!SensorPortMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:01'!
wantedDroppedMorphClasses
	"Devuelve un array con las clases que pueden conectarse a este puerto"
	^NxtSensorMorph allSubclasses asArray! !

!SensorPortMorph methodsFor: 'as yet unclassified' stamp: 'Richo 2/16/2009 15:55'!
defaultPositions
	^ ({-200 @ 100. -75 @ 200. 75 @ 200. 200 @ 100}
		collect: [:each | each + self center])
		at: port portNumber ! !

!SensorPortMorph methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 23:13'!
letters
^#('1' '2' '3' '4')! !

ImageMorph subclass: #NxtPluggableDeviceMorph
	instanceVariableNames: 'connector device attachmentPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Model'!

NxtPluggableDeviceMorph subclass: #NxtMotorMorph
	instanceVariableNames: 'automaticBrake lastTimeSent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Model'!

NxtMotorMorph class
	instanceVariableNames: 'form'!

NxtMotorMorph class
	instanceVariableNames: 'form'!

!NxtMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 2/25/2009 14:17'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that
	characterize the phrases this kind of morph wishes to add to various
	Viewer categories."
	^ #(#(#'lego nxt' #(#(#command #float '') #(#command #brake '')  #(#command #resetRelative: 'no se que hace esto' #Boolean) #(#slot #automaticBrake '' #Boolean #readWrite #Player #getAutomaticBrake #Player #setAutomaticBrake:) #(#slot #power '' #Number #readWrite #Player #getPower #Player #setPower:) #(#slot #rotation 'todavia no se como interpretar esto' #Number #readOnly #Player #getRotation #unused #unused))) )! !

!NxtMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2008 17:50'!
defaultNameStemForInstances
^'Nxt Motor'! !

!NxtMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2008 17:45'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Nxt Motor'
		categories: #('LegoNxt' )
		documentation: ''! !

!NxtMotorMorph class methodsFor: 'form' stamp: 'Richo 10/6/2008 17:52'!
form
	^ form
		ifNil: [
			self initializeForm]! !

!NxtMotorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2008 17:46'!
includeInNewMorphMenu
	^ true! !

!NxtMotorMorph class methodsFor: 'form' stamp: 'Richo 11/17/2009 13:30'!
initializeForm
	^ form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAUoAAACOCAYAAABXJ0ETAAAABHNCSVQFBQUBSsjp7wAAD+xJ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'! !

!NxtMotorMorph class methodsFor: 'factory' stamp: 'Richo 10/15/2008 15:05'!
myDevice
	^ NxtMotor new! !

!NxtMotorMorph methodsFor: 'attachment point' stamp: 'Richo 11/10/2009 12:51'!
attachmentPointCenter
^ ( -162@-19)! !

!NxtMotorMorph methodsFor: 'accessing' stamp: 'Richo 2/3/2009 12:37'!
automaticBrake
^automaticBrake! !

!NxtMotorMorph methodsFor: 'accessing' stamp: 'Richo 2/3/2009 12:38'!
automaticBrake: aBoolean
 automaticBrake:= aBoolean! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 2/16/2009 17:32'!
brake
	self isPlugged
		ifFalse: [^ self].
[	self device brake] on: NotConnectedLego do: []! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 2/16/2009 17:29'!
float
	self isPlugged
		ifFalse: [^ self].
	[self device float] on: NotConnectedLego do: []! !

!NxtMotorMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 13:00'!
initialize
	super initialize.
	automaticBrake := true.
	lastTimeSent := Time new.
	! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 2/16/2009 16:11'!
power
	^ [self device power]
		on: Error
		do: [0]! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 2/16/2009 17:31'!
power: aNumber 
	self isPlugged
		ifFalse: [^ self].
	[self device power: aNumber] on: NotConnectedLego do: [].
	lastTimeSent := Time now! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 2/16/2009 17:32'!
resetRelative: aBoolean 
	self isPlugged
		ifFalse: [^ self].
[	self device resetRelative: aBoolean]
	on: NotConnectedLego do: []! !

!NxtMotorMorph methodsFor: 'actions' stamp: 'Richo 11/27/2008 15:45'!
rotation
	^ [self device rotation]
		on: Error
		do: [-1]! !

!NxtMotorMorph methodsFor: 'stepping' stamp: 'Richo 2/16/2009 16:34'!
step
	"Mando #step a super porque NxtConectableDeviceMorph, que es
	superclase, controla las conexiones y la orientacin. No sacar!!"
	super step.
	self isPlugged
		ifFalse: [^ self].
	automaticBrake
		ifTrue: [Time now asDuration - lastTimeSent asDuration
					> (Duration seconds: 1)
				ifTrue: [[self float] on: Error do: []]]! !

!NxtMotorMorph methodsFor: 'initialize-release' stamp: 'Richo 2/16/2009 16:10'!
unplug
	self float.
	super unplug! !

!NxtPluggableDeviceMorph class methodsFor: 'form' stamp: 'Richo 10/15/2008 14:59'!
flippedForm
	^ self form flipBy: #horizontal centerAt: self form center! !

!NxtPluggableDeviceMorph class methodsFor: 'form' stamp: 'Richo 10/15/2008 14:58'!
form
^self subclassResponsibility! !

!NxtPluggableDeviceMorph class methodsFor: 'factory' stamp: 'Richo 10/15/2008 15:00'!
myDevice
^self subclassResponsibility! !

!NxtPluggableDeviceMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 12:53'!
attachmentPoint
^attachmentPoint ! !

!NxtPluggableDeviceMorph methodsFor: 'attachment point' stamp: 'Richo 11/10/2009 12:53'!
attachmentPointCenter
^0@0! !

!NxtPluggableDeviceMorph methodsFor: 'attachment point' stamp: 'Richo 11/10/2009 12:56'!
attachmentPointFlippedCenter
^self attachmentPointCenter x negated @ self attachmentPointCenter y! !

!NxtPluggableDeviceMorph methodsFor: 'accessing' stamp: 'Richo 10/15/2008 14:46'!
connector: aConnector
connector := aConnector! !

!NxtPluggableDeviceMorph methodsFor: 'stepping' stamp: 'Richo 2/11/2009 13:43'!
controlConnection
	"Muy importante!! Controla que slo puedan mandarse mensajes al nxt si
	se est conectado al brick"
	device isPlugged
		ifFalse: [^ self].
	connector isNil
		ifTrue: [^ self unplug].
	connector isPlugged
		ifFalse: [^ self unplug]! !

!NxtPluggableDeviceMorph methodsFor: 'stepping' stamp: 'Richo 11/10/2009 12:56'!
controlOrientation
	connector isNil
		ifTrue: [^ self].
	connector sourceMorph isNil
		ifTrue: [^ self].
	self center x < (connector sourceMorph center x - 50)
		ifTrue: [self image = self class flippedForm
				ifFalse: [self image: self class flippedForm.
						attachmentPoint center: self center  + self attachmentPointFlippedCenter.
						]].
	self center x > (connector sourceMorph center x + 50)
		ifTrue: [self image = self class flippedForm
				ifFalse: [self image: self class form.
						attachmentPoint center: self center + self attachmentPointCenter.						
						]]! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 3/5/2009 16:14'!
delete
	connector isNil
		ifFalse: [connector delete].
	[self unplug]
		on: NotConnectedLego
		do: [].
	^ super delete! !

!NxtPluggableDeviceMorph methodsFor: 'accessing' stamp: 'Richo 10/15/2008 14:50'!
device
^device! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 13:01'!
initialize
super initialize.
device := self class myDevice.
self image: self class form.
self initializeAttachmentPoint.! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 12:52'!
initializeAttachmentPoint
	attachmentPoint := PEAttachmentPointMorph new 
				color: Color black;
				 borderWidth: 0;
				 extent: 1 @ 1;
				 center: self center + self attachmentPointCenter.
	self addMorph: attachmentPoint! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 10/15/2008 14:54'!
initializeToStandAlone
self initialize! !

!NxtPluggableDeviceMorph methodsFor: 'testing' stamp: 'Richo 2/11/2009 13:43'!
isPlugged
	^ device isPlugged! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 10/15/2008 14:46'!
moveTo: dest 
	| opuesto adyacente pasosOpuesto pasosAdyacente x y diff maxPasos |
	x := self center x.
	y := self center y.
	diff := self center - dest.
	opuesto := diff y abs.
	adyacente := diff x abs.
	maxPasos := 10.
	pasosOpuesto := opuesto / maxPasos * diff y sign.
	pasosAdyacente := adyacente / maxPasos * diff x sign.
	[maxPasos
		timesRepeat: [x := x - pasosAdyacente.
			y := y - pasosOpuesto.
			self center: x rounded @ y rounded.
			(Delay forMilliseconds: 1) wait]]
		forkNamed: self class asString, ' moveTo: ' , dest asString! !

!NxtPluggableDeviceMorph methodsFor: 'accessing' stamp: 'Richo 2/11/2009 14:25'!
newPlayerInstance
	^ SqueakNxtPlayer newUserInstance! !

!NxtPluggableDeviceMorph methodsFor: 'stepping' stamp: 'Richo 10/21/2008 14:46'!
step
	self controlConnection.
		self controlOrientation.! !

!NxtPluggableDeviceMorph methodsFor: 'stepping' stamp: 'Richo 10/21/2008 15:42'!
stepTime
	^ 200! !

!NxtPluggableDeviceMorph methodsFor: 'initialize-release' stamp: 'Richo 3/5/2009 16:14'!
unplug
self isPlugged ifFalse: [^self].
	device unplug! !

!NxtPluggableDeviceMorph methodsFor: 'viewer category filter' stamp: 'Richo 10/15/2008 14:49'!
wantsConnectionVocabulary

^false! !

!NxtPluggableDeviceMorph methodsFor: 'viewer category filter' stamp: 'Richo 10/15/2008 14:49'!
wantsConnectorVocabulary
	^ false! !

!NxtPluggableDeviceMorph methodsFor: 'viewer category filter' stamp: 'Richo 10/15/2008 17:19'!
wantsEmbeddingsVocabulary
	^ false! !

NxtPluggableDeviceMorph subclass: #NxtSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Model'!

NxtSensorMorph class
	instanceVariableNames: 'form'!

NxtSensorMorph class
	instanceVariableNames: 'form'!

NxtSensorMorph subclass: #LightSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Model'!

!LightSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 12/31/2008 15:33'!
additionsToViewerCategories
	^ #(#(#'lego nxt' #(#(#slot #active '' #Boolean #readWrite #Player #getActive #Player #setActive:) #(#slot #value '' #Number #readOnly #Player #getValue #unused #unused))) )! !

!LightSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/15/2008 17:39'!
defaultNameStemForInstances
	^ 'Nxt Light Sensor'! !

!LightSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:26'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Nxt Light Sensor'
		categories: #('LegoNxt' )
		documentation: ''! !

!LightSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/17/2009 13:29'!
initializeForm
	^ form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAFwAAAB2CAYAAABF2PQIAAAABHNCSVQFBQUBSsjp7wAABY9J
REFUeF7lnT92ozAQxild7hFcUrrkCC4pU+4RUlKmTLlHcOnSpcs9To6Qjs3Yi6MMGmnQP7A+
3tMjim0wX778GI2E1IRtuxG/TCXrhi9wIeHxBS0kvPvgXdeNr6+vcCWT6PIBD4fDeLlcxo+P
D9jiFz6B2IdDN57PZ+cXode34kTfd80vfITghA/phGah99XEZI5NyWQRotudvewk9RcuvqxH
pLPpRMRw/Gjkfi+LEN3vbKpLJ9/v92Pf9+PxeByHYRhPp9OjnI2fn6VO1zFdj094M4BQiq5j
tnRCEphOZH75GutkKo3oMgEcgnOxpYMMr8NTO3lpna5Xw3S7XoLYmg+3bVutkzV1un6XbuR4
QXT3jcAWZ+73bfVO1tRtZuWxv1dwH7fRnW3W6d7lu/ctEtzmbnxnz6MZl4aLBOev9cce39mK
6MVk+bzlLcTdLnfjO3tel7Ay11H4y/A3PtiN72xrnUctMimUgt8aN/hOFuuc5XILXSk4vpPd
dUoD6IIPpeD4Tl4WrUQLju9kdz2Lw9dyEt0/puydlKk0s3tbY3iYwwu34Eg8V3ZOU/AZrnBy
rMg255fIzz8Vw0kQW/bNmg7uqTSzve9z5EB8hjuyblzk67AbP8/N+HlqxD29p9s3Dse3+Ax3
OZucexNzYXE5PpfTN89wqeeEHHp3dON1tG/v6hKEYrgtjzyJHeJot9vdokMw3Cn2Kf2e2J6b
6ZtluK3xksPZvEiip3L6Zhluu+hcztY4nWL1ahlOPUb8gh/hXqFiY3qKcTWbZDgx8wdK2jLO
NvcU/dhcXiXD13a3K06vkuGxUYkVB/2dzUudnnoE2SYZ/sPdb7voCCP0eDaWx7ZAN8dw7gCt
E125EVvOJbQlSt+vKoZzB4Sy9s/1ffz7eb2V96+fD10b7HTzj/lweC0MD3E4F/su9OW2v/7f
U/338BIU15tYie0p2hzDTQdosoDkVPP8JOrkbF5emODa6Mf8D6qa4RrWcpzYnG3WQ1jOHV4t
wzUO51GE5O6phOTRrQ6vkeEqhx9/Ovz9+iYynG6kKRwOzXDeOKFoRMvwkBbnKgw3HwLlj0uU
ZjjtKdfCb5yc4eT81ggNl7RgczKcj0oWx4dLpTTDpRYmOZ0cTeK3XRvV4szJcMeTyfpBNSUZ
/p3d282cnqqlmZPh0YKvwXBN32RMj1FOhgc8e79bneFS9GIOAorJj+dleOR8KWswvGRePD3D
IwVfi+E593kZHuvwlRlO0Qd9rmsZv9vwnqO8DE/g8LUY7rphpoxS8BluyRqm7PnBZ7im77H5
+v2v70L10HEu+Az39PhwsSXRo7KFyAw3W5jdzi72VGYNIXyGx2ULB4/g9HpMnyk+w086nEhY
wWd4pMN9SOlSORyZ4Tz+vgqiX3fN5vo0n5LhPB9OLraxnLs7qtcePQ7XDHOzio3P8PBciuY5
zNjj4jN8Qc8Pxd1LnI3P8ICs4dQJsXTULD7D8fPh28yHF+vxwWd4OYdviuGP5xnx+zTLMDwl
4/AZrhA8dt5CfIZHhIb4DM/CcOHGic/wXAyfC87/7fAZ/l2fz9WVaHmw0PnDa2d4wjXZ/FNe
oDPcPuFO4kXwlsblNTN8PktGpiUelzi9VoZncLd7QTyt02tluH1WuswLmWrmG6mR4Rnd7Rfd
F73UyHD7tK2F10aW5nqtieHy4yXZN/dcr+YyBjUwnKIR9xy5RTb8ZR4Lio0v+gpiI4v/tFv+
WZxvs+4fe3Sh54KXXFGqwd3KraaCL7jF4TlXI8EXvBDDpzq+4PgMx2c4PsPxGY7PcHyG4zMc
n+H4DMcXHJ/h+AzHZzg+w/EZjs9wfIbjMxyf4fhIwWc4PsPxGY7PcHyG4zMcn+H4DH8iwWkU
Kw2szLXHF5wJjj9UDV/wpNs/44yFQ/nAYOUAAAAASUVORK5CYII='! !

!LightSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 15:16'!
myDevice
	^ LightSensor new! !

!LightSensorMorph methodsFor: 'accessing' stamp: 'Richo 10/17/2008 15:20'!
active
	^ self device isActive! !

!LightSensorMorph methodsFor: 'accessing' stamp: 'Richo 10/17/2008 15:19'!
active: aBoolean 
	aBoolean
		ifTrue: [self device setActive]
		ifFalse: [self device setInactive]! !

!LightSensorMorph methodsFor: 'accessing' stamp: 'Richo 11/26/2008 14:05'!
value
	^ (self normalizedValue * 100 / 1023) asInteger! !

!NxtSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 12/31/2008 15:33'!
additionsToViewerCategories
	^ #(#(#'lego nxt-advanced' #(#(#slot #rawValue '' #Number #readOnly #Player #getRawValue #unused #unused) #(#slot #normalizedValue '' #Number #readOnly #Player #getNormalizedValue #unused #unused) #(#slot #scaledValue '' #Number #readOnly #Player #getScaledValue #unused #unused))) )! !

!NxtSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:55'!
form
	^ form
		ifNil: [self initializeForm]! !

!NxtSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:56'!
includeInNewMorphMenu
	^ true! !

!NxtSensorMorph methodsFor: 'attachment point' stamp: 'Richo 11/10/2009 13:03'!
attachmentPointCenter
^self bottomCenter - self center - (0@2)! !

!NxtSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 3/5/2009 15:44'!
normalizedValue
	[[^ self device normalizedValue]
		on: UnpluggedDevice
		do: [^ 0]]
		on: NotConnectedLego
		do: [^ 0]! !

!NxtSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 3/5/2009 15:44'!
rawValue
	[[^ self device rawValue]
		on: UnpluggedDevice
		do: [^ 0]]
		on: NotConnectedLego
		do: [^ 0]! !

!NxtSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 3/5/2009 15:44'!
scaledValue
	[[^ self device scaledValue]
		on: UnpluggedDevice
		do: [^ 0]]
		on: NotConnectedLego
		do: [^ 0]! !

!NxtSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:18'!
value
^self rawValue! !

NxtSensorMorph subclass: #SoundSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Model'!

!SoundSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 12/31/2008 15:33'!
additionsToViewerCategories
	^ #(#(#'lego nxt' #(#(#slot #audible '' #Boolean #readWrite #Player #getAudible #Player #setAudible:) #(#slot #value '' #Number #readOnly #Player #getValue #unused #unused))) )! !

!SoundSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:56'!
defaultNameStemForInstances
	^ 'Nxt Sound Sensor'! !

!SoundSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:56'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Nxt Sound Sensor'
		categories: #('LegoNxt' )
		documentation: ''! !

!SoundSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/17/2009 13:32'!
initializeForm
^form := PEUtilities formFromEncodedPNG: 
 'iVBORw0KGgoAAAANSUhEUgAAAFwAAAB2CAYAAABF2PQIAAAABHNCSVQFBQUBSsjp7wAABvpJ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'! !

!SoundSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:57'!
myDevice
	^ SoundSensor new! !

!SoundSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:17'!
audible
^self device isAudible! !

!SoundSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:16'!
audible: aBoolean
aBoolean ifTrue:[
self device setAudible]
ifFalse: [self device setInaudible]! !

!SoundSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/26/2008 14:05'!
value
	^ (self normalizedValue * 100 / 1023) asInteger! !

NxtSensorMorph subclass: #SwitchSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Model'!

!SwitchSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 12/31/2008 15:33'!
additionsToViewerCategories
	^ #(#(#'lego nxt' #(#(#slot #isPressed '' #Boolean #readOnly #Player #getIsPressed #unused #unused))) )! !

!SwitchSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:21'!
defaultNameStemForInstances
	^ 'Nxt Switch Sensor'! !

!SwitchSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:22'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Nxt Switch Sensor'
		categories: #('LegoNxt' )
		documentation: ''! !

!SwitchSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/17/2009 13:33'!
initializeForm
^form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAFwAAAB2CAYAAABF2PQIAAAABHNCSVQFBQUBSsjp7wAABi5J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'! !

!SwitchSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 16:22'!
myDevice
	^ SwitchSensor new! !

!SwitchSensorMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/25/2008 14:37'!
isPressed
	^ self normalizedValue < 500! !

NxtSensorMorph subclass: #UltrasonicSensorMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Model'!

!UltrasonicSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:38'!
defaultNameStemForInstances
	^ 'Nxt Ultrasonic Sensor'! !

!UltrasonicSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:39'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Nxt Ultrasonic Sensor'
		categories: #('LegoNxt' )
		documentation: ''! !

!UltrasonicSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/17/2009 13:34'!
initializeForm
^form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAAKwAAABkCAYAAAAbitsBAAAABHNCSVQFBQUBSsjp7wAACIVJ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'! !

!UltrasonicSensorMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:39'!
myDevice
^UltrasonicSensor new! !

Error subclass: #AlreadyPluggedDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Errors'!

Error subclass: #BusyPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Errors'!

Error subclass: #NotConnectedLego
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Errors'!

Error subclass: #NxtError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError class
	instanceVariableNames: 'dict'!

NxtError class
	instanceVariableNames: 'dict'!

NxtError subclass: #AttemptedToAccessInvalidFieldOfAStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #BadArguments
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #BadInputOrOutputSpecified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #CommunicationBusError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #DataContainsOutOfRangeValues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #IllegalMailboxQueueIDSpecified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #IllegalSizeSpecified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #InsanePacket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #InsufficientMemoryAvailable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #NoActiveProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #NoFreeMemoryInCommunicationBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

!NxtError class methodsFor: 'as yet unclassified' stamp: 'Richo 9/30/2008 15:27'!
code: anErrorCode

^self dict at: anErrorCode! !

!NxtError class methodsFor: 'as yet unclassified' stamp: 'Richo 12/1/2008 13:06'!
dict
	^ dict
		ifNil: [dict := Dictionary new add: 16r20 -> PendingCommunicationTransactionInProgress;
						 add: 16r40 -> SpecifiedMailboxQueueIsEmpty;
						 add: 16rBD -> RequestFailed;
						 add: 16rBE -> UnknownCommandOpcode;
						 add: 16rBF -> InsanePacket;
						 add: 16rC0 -> DataContainsOutOfRangeValues;
						 add: 16rDD -> CommunicationBusError;
						 add: 16rDE -> NoFreeMemoryInCommunicationBuffer;
						 add: 16rDF -> SpecifiedChannelConnectionIsNotValid;
						 add: 16rE0 -> SpecifiedChannelConnectionNotConfiguredOrBusy;
						 add: 16rEC -> NoActiveProgram;
						 add: 16rED -> IllegalSizeSpecified;
						 add: 16rEE -> IllegalMailboxQueueIDSpecified;
						 add: 16rEF -> AttemptedToAccessInvalidFieldOfAStructure;
						 add: 16rF0 -> BadInputOrOutputSpecified;
						add: 16rFB -> InsufficientMemoryAvailable ;
						 add: 16rFF -> BadArguments;
						 yourself]! !

NxtError subclass: #PendingCommunicationTransactionInProgress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #RequestFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #SpecifiedChannelConnectionIsNotValid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #SpecifiedChannelConnectionNotConfiguredOrBusy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #SpecifiedMailboxQueueIsEmpty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

NxtError subclass: #UnknownCommandOpcode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC-NxtErrors'!

Error subclass: #UnpluggedDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Errors'!

PolygonMorph subclass: #LittleArrowMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-ControlPanel'!

!LittleArrowMorph class methodsFor: 'instance creation' stamp: 'Richo 10/7/2008 17:05'!
leftArrow
	^ self
		vertices: {-5 @ 0. 0 @ 5. 0 @ -5}
		color: Color black
		borderWidth: 0
		borderColor: Color black! !

!LittleArrowMorph class methodsFor: 'instance creation' stamp: 'Richo 10/6/2008 18:50'!
rightArrow
	^ self
		vertices: {5 @ 0. 0 @ 5. 0 @ -5}
		color: Color black
		borderWidth: 0
		borderColor: Color black! !

!LittleArrowMorph methodsFor: 'as yet unclassified' stamp: 'Richo 10/6/2008 18:52'!
step
	self color = Color black
		ifTrue: [self color: Color transparent]
		ifFalse: [self color: Color black]! !

!LittleArrowMorph methodsFor: 'as yet unclassified' stamp: 'Richo 10/6/2008 18:54'!
stepTime
	^ self color = Color black
		ifTrue: [900]
		ifFalse: [300]! !

PolygonMorph subclass: #NxtButtonMorph
	instanceVariableNames: 'originalColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-ControlPanel'!

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:31'!
cancelButton
	| verts |
	verts := {0 @ 0. 30 @ 0. 30 @ 25. 0 @ 25}.
	^ (self
		vertices: verts
		color: (Color gray mixed: 0.5 with: Color white)
		borderWidth: 3
		borderColor: Color black)! !

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:26'!
leftButton
	| verts |
	verts := {0 @ 0. 0 @ 34. -25 @ 17}.
	^ self
		vertices: verts
		color: Color gray muchLighter
		borderWidth: 3
		borderColor: Color black! !

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:26'!
okButton
	| verts |
	verts := {0 @ 0. 0 @ 35. 35 @ 35. 35 @ 0}.
	^ self
		vertices: verts
		color: Color orange
		borderWidth: 3
		borderColor: Color black! !

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:26'!
rightButton
	| verts |
	verts := {0 @ 0. 0 @ 34. 25 @ 17}.
	^ self
		vertices: verts
		color: Color gray muchLighter
		borderWidth: 3
		borderColor: Color black! !

!NxtButtonMorph class methodsFor: 'instance creation' stamp: 'Richo 10/2/2008 16:35'!
vertices: verts color: c borderWidth: bw borderColor: bc 
	^ (super
		vertices: verts
		color: c
		borderWidth: bw
		borderColor: bc) initialize! !

!NxtButtonMorph methodsFor: 'initialization' stamp: 'Richo 10/2/2008 16:35'!
initialize
	"No hacer 'super initialize' porque dibuja un triangulito"
	originalColor := self color.
	self
		on: #mouseEnter
		send: #mouseEnter:forMorph:
		to: self;
		
		on: #mouseLeave
		send: #mouseLeave:forMorph:
		to: self! !

!NxtButtonMorph methodsFor: 'event handling' stamp: 'Richo 10/2/2008 16:35'!
mouseEnter: evt forMorph: aMorph 

	self color: originalColor muchLighter! !

!NxtButtonMorph methodsFor: 'event handling' stamp: 'Richo 10/2/2008 16:33'!
mouseLeave: evt forMorph: aMorph 
	self color: originalColor! !

Player subclass: #SqueakNxtPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Player'!

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
brake
	^ self costume renderedMorph  brake! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 11/10/2009 16:41'!
connect
^ self costume renderedMorph connect! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 11/10/2009 16:41'!
disconnect
^ self costume renderedMorph disconnect! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
float
	^ self costume renderedMorph  float! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getActive
	^ self costume  renderedMorph active! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getAudible
	^ self costume renderedMorph  audible! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getAutomaticBrake
	^ self costume renderedMorph  automaticBrake! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getBatteryLevel
	^ self costume renderedMorph  getBatteryLevel! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 11/10/2009 16:41'!
getIsConnected
^ self costume renderedMorph isConnected! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getIsPressed
	^ self costume renderedMorph  isPressed! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getNormalizedValue
	^ self costume  renderedMorph normalizedValue! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 11/10/2009 16:38'!
getNxtPortName
 ^ self costume renderedMorph portName! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getPower
	^ self costume renderedMorph  power! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getRawValue
	^ self costume renderedMorph  rawValue! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getRotation
	^ self costume renderedMorph  rotation! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:23'!
getScaledValue
	^ self costume  renderedMorph scaledValue! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
getValue
	^ self costume  renderedMorph value! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
playSoundFile: aString 
	^ self costume renderedMorph  playSoundFile: aString! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
playTone: aNumber 
	^ self costume renderedMorph  playTone: aNumber! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
resetRelative: aBoolean 
	^ self costume  renderedMorph resetRelative: aBoolean! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
setActive: aBoolean 
	^ self costume renderedMorph  active: aBoolean! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
setAudible: aBoolean 
	^ self costume  renderedMorph audible: aBoolean! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
setAutomaticBrake: aBoolean 
	self costume renderedMorph  automaticBrake: aBoolean! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 11/10/2009 15:36'!
setIsConnected: aBoolean
! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 11/10/2009 16:38'!
setNxtPortName: aSymbol
	^ self costume renderedMorph
		portName: aSymbol! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
setPower: aNumber 
	self costume  renderedMorph power: aNumber! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
startProgram: aString 
	^ self costume renderedMorph  startProgram: aString! !

!SqueakNxtPlayer methodsFor: 'slots and commands' stamp: 'Richo 2/11/2009 14:24'!
stopProgram: aString 
	^ self costume renderedMorph  stopProgram: aString! !

PEWireMorph subclass: #SqueakNxtWireMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Wiring'!

!SqueakNxtWireMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/10/2009 13:08'!
validConnectionClasses
	^ super validConnectionClasses,
	{  PortMorph}! !

!SqueakNxtWireMorph methodsFor: 'as yet unclassified' stamp: 'Richo 11/11/2009 14:35'!
initialize
super initialize.
self lineColor: Color black; lineWidth: 10; beSmoothCurve; beOrthogonal: true! !

AlignmentMorph subclass: #LegoNxtMorph
	instanceVariableNames: 'nxt portName controlPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Model'!

!LegoNxtMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 11/10/2009 16:38'!
additionsToViewerCategories
^  #(
	#(
		#'lego nxt - connection' 
		#(
			#(command connect '' )
			#(command disconnect '' )
			#(slot isConnected '' Boolean readOnly Player getIsConnected Player unused )
			#(slot portName '' SqueakNxtPort readWrite Player getNxtPortName Player setNxtPortName: ) 
		)
		#'lego nxt - other stuff' 
		#(
			#(#command #playSoundFile: '' #String) 
			#(#command #playTone: '' #Number) 
			#(#command #startProgram: '' #String) 
			#(#command #stopProgram: '' #String)
		)
	) 
)


! !

!LegoNxtMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2008 17:50'!
defaultNameStemForInstances
^'Nxt Brick'! !

!LegoNxtMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2008 17:43'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Nxt Brick'
		categories: #('LegoNxt' )
		documentation: ''! !

!LegoNxtMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2008 17:43'!
includeInNewMorphMenu
	^ true! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 11/11/2009 16:34'!
connect
self connectNxtOnPort: portName.
controlPanel resetDisplay
! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 11/10/2009 16:03'!
connectNxtOnPort: aString
	"Si logra conectarse manda un sonidito al nxt"
	nxt isConnected
		ifTrue: [^ self].
	[nxt connectOnPort: aString] on: BusyPort do: [].
	nxt isConnected
		ifTrue: [ | delay |
			delay := Delay forMilliseconds: 200.
			self playTone: 2500.
			delay wait.
			self playTone: 2000.
			delay wait.
			self playTone: 2500]! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 11/11/2009 16:34'!
delete
	self disconnect. 
	super delete
! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 11/11/2009 16:34'!
disconnect
	[nxt disconnect]
		on: NotConnectedLego
		do: [].
	controlPanel resetDisplay
! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 11/3/2008 16:14'!
getBatteryLevel
	^ nxt isConnected
		ifTrue: [nxt getBatteryLevel]
		ifFalse: [0]! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 16:08'!
initialize
	super initialize.
	self borderWidth: 1;
		 borderColor: #raised;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #topToBottom;
		 cornerStyle: #rounded;
		 color: Color black.
		nxt := LegoNxt new.
	self initializePortName.
	self initializeSubmorphs! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 16:39'!
initializePortName
	| availablePorts list |
	list :=PESerialPortList.
	availablePorts := (list availableBluetoothPorts) asSet asSortedCollection.
	availablePorts := availablePorts, #(#'other...').
	Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #SqueakNxtPort;
			 symbols: availablePorts).

	portName := availablePorts first! !

!LegoNxtMorph methodsFor: 'initialize-release' stamp: 'Richo 11/10/2009 17:45'!
initializeSubmorphs
	self
		addMorphBack: (MotorsBarMorph on: self);
		 addMorphBack: (controlPanel := (ControlPanelMorph on: self));
		
		addMorphBack: (SensorsBarMorph on: self)! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 11/24/2008 16:10'!
isConnected
	^ nxt isConnected! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 2/11/2009 14:25'!
newPlayerInstance
^SqueakNxtPlayer newUserInstance! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 10/15/2008 15:17'!
nxt
^nxt! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 11/3/2008 16:15'!
playSoundFile: aString 
	nxt isConnected
		ifTrue: [nxt playSoundFile: aString]! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 11/3/2008 16:15'!
playTone: freqNumber 
	nxt isConnected
		ifTrue: [nxt playTone: freqNumber]! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 16:26'!
portName
 ^portName! !

!LegoNxtMorph methodsFor: 'accessing' stamp: 'Richo 11/10/2009 17:45'!
portName: aSymbol

portName :=  (aSymbol = #'other...'
				ifTrue: [(FillInTheBlank request: 'Port name:')  asSymbol]
				ifFalse: [aSymbol]).
controlPanel portName: portName.! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 11/3/2008 16:16'!
startProgram: aString 
	nxt isConnected
		ifTrue: [nxt startProgram: aString]! !

!LegoNxtMorph methodsFor: 'actions' stamp: 'Richo 11/3/2008 16:19'!
stopProgram: aString 
	nxt isConnected
		ifTrue: [nxt stopProgram: aString]! !

!LegoNxtMorph methodsFor: 'viewer category filter' stamp: 'Richo 10/7/2008 18:16'!
wantsConnectionVocabulary
	^ false! !

!LegoNxtMorph methodsFor: 'viewer category filter' stamp: 'Richo 10/7/2008 18:16'!
wantsConnectorVocabulary
	^ false! !

!LegoNxtMorph methodsFor: 'viewer category filter' stamp: 'Richo 10/7/2008 18:15'!
wantsEmbeddingsVocabulary
	^ false! !

AlignmentMorph subclass: #MotorsBarMorph
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Bars'!

!MotorsBarMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:50'!
on: aLegoNxtMorph 
	^ self basicNew setMain: aLegoNxtMorph;
		 initialize! !

!MotorsBarMorph methodsFor: 'initializing' stamp: 'Richo 9/29/2008 22:14'!
initialize
	super initialize.
	self borderWidth: 0;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #leftToRight;
		 color: Color black.
	self initializeSubmorphs! !

!MotorsBarMorph methodsFor: 'initializing' stamp: 'Richo 2/16/2009 15:50'!
initializeSubmorphs
	self
		addMorphBack: (MotorPortMorph port: main nxt portA);
		
		addMorphBack: (MotorPortMorph port: main nxt portB);
		
		addMorphBack: (MotorPortMorph port: main nxt portC);
		 addMorphBack: (Morph new
			color: (Color gray mixed: 0.5 with: Color white);
			 borderColor: Color black;
			 borderWidth: 2;
			 height: 30)! !

!MotorsBarMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 15:50'!
setMain: aLegoNxtMorph 
main := aLegoNxtMorph! !

AlignmentMorph subclass: #SensorsBarMorph
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Etoys-Bars'!

!SensorsBarMorph class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:51'!
on: aLegoNxtMorph 
^self basicNew setMain: aLegoNxtMorph; initialize! !

!SensorsBarMorph methodsFor: 'initializing' stamp: 'Richo 9/29/2008 23:14'!
initialize
	super initialize.
	self borderWidth: 0;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 listDirection: #leftToRight;
		 color: Color black.
	self initializeSubmorphs! !

!SensorsBarMorph methodsFor: 'initializing' stamp: 'Richo 2/16/2009 15:53'!
initializeSubmorphs
	self
		addMorphBack: (SensorPortMorph port: main nxt port1);
		
		addMorphBack: (SensorPortMorph  port: main nxt port2);
		
		addMorphBack: (SensorPortMorph  port: main nxt port3);
		
		addMorphBack: (SensorPortMorph  port: main nxt port4)! !

!SensorsBarMorph methodsFor: 'private' stamp: 'Richo 2/16/2009 15:52'!
setMain: aLegoNxtMorph 
main := aLegoNxtMorph! !

Object subclass: #DirectCommand
	instanceVariableNames: 'commMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!DirectCommand class methodsFor: 'instance creation' stamp: 'Richo 12/3/2008 13:46'!
on: commMode 
	^ self basicNew setCommMode: commMode! !

!DirectCommand methodsFor: 'checking' stamp: 'Richo 12/2/2008 16:41'!
isValid: aByteArray 
	aByteArray isEmpty
		ifTrue: [^ false].
	(aByteArray at: 5)
			= 0
		ifTrue: [^ true].
	(NxtError code: (aByteArray at: 5) asInteger) signal! !

!DirectCommand methodsFor: 'sending-receiving' stamp: 'Richo 12/3/2008 13:53'!
receiveAndCheck
	"Hice una pequea prueba mandando un direct command
	aproximadamente cada 10 milisegundos y para todos los sensores y
	motores. De un total de 644 direct commands, el promedio tard 5523
	ciclos. Solamente 35 superaron los 10000 pedidos, as que puse 10000. Si
	no funciona cambiar"
	| received count |
	count := 0.
	[received := commMode receive.
	count := count + 1]
		doWhileTrue: [(self isValid: received) not
				and: [count < 10000]].
			Transcript show: count; cr.
	^ received! !

!DirectCommand methodsFor: 'sending-receiving' stamp: 'Richo 11/4/2008 14:48'!
send: aByteString 
	commMode send: aByteString! !

!DirectCommand methodsFor: 'private' stamp: 'Richo 11/4/2008 14:48'!
setCommMode: aLegoNxt 
	commMode := aLegoNxt! !

DirectCommand subclass: #ForceError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!ForceError methodsFor: 'as yet unclassified' stamp: 'Richo 9/30/2008 15:40'!
getError
| msg |
msg := 0 asCharacter asString, 1 asCharacter asString.
self send: msg.
^self receiveAndCheck! !

DirectCommand subclass: #GetBatteryLevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!GetBatteryLevel methodsFor: 'as yet unclassified' stamp: 'Richo 12/2/2008 16:27'!
isValid: aByteArray 
	super isValid: aByteArray.
	^ aByteArray size = 7! !

!GetBatteryLevel methodsFor: 'as yet unclassified' stamp: 'Richo 9/30/2008 15:00'!
value
	| msg |
	msg := 0 asCharacter asString , 11 asCharacter asString.
	self send: msg.
	^ self receiveAndCheck! !

DirectCommand subclass: #GetInputValues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!GetInputValues methodsFor: 'as yet unclassified' stamp: 'Richo 12/2/2008 16:29'!
isValid: aByteArray 
	super isValid: aByteArray.
	^ aByteArray size = 18! !

!GetInputValues methodsFor: 'as yet unclassified' stamp: 'Richo 9/30/2008 14:59'!
port: inputPort 
	"inputPort Range: 0-3"
	| msg |
	msg := 0 asCharacter asString , 7 asCharacter asString , inputPort asCharacter asString.
	self send: msg.
	^self receiveAndCheck! !

DirectCommand subclass: #GetOutputState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!GetOutputState methodsFor: 'as yet unclassified' stamp: 'Richo 12/2/2008 16:29'!
isValid: aByteArray 
	super isValid: aByteArray.
	^ aByteArray size = 27! !

!GetOutputState methodsFor: 'as yet unclassified' stamp: 'Richo 11/25/2008 16:05'!
port: outputPort 
	"outputPort Range: 0-2"
	| msg |
	msg := 0 asCharacter asString , 6 asCharacter asString , outputPort asCharacter asString.
	self send: msg.
	^ self receiveAndCheck! !

DirectCommand subclass: #LSGetStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!LSGetStatus methodsFor: 'as yet unclassified' stamp: 'Richo 12/2/2008 16:29'!
isValid: aByteArray 
	super isValid: aByteArray.
	^ aByteArray size = 6! !

!LSGetStatus methodsFor: 'as yet unclassified' stamp: 'Richo 10/21/2008 15:45'!
port: inputPort 
	"inputPort Range: 0-3"
	| msg |
	msg := 0 asCharacter asString , 16r0E asCharacter asString , inputPort asCharacter asString.
	self send: msg.
	^ self receiveAndCheck! !

DirectCommand subclass: #LSRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!LSRead methodsFor: 'as yet unclassified' stamp: 'Richo 12/2/2008 16:29'!
isValid: aByteArray 
	super isValid: aByteArray.
	^ aByteArray size = 22! !

!LSRead methodsFor: 'as yet unclassified' stamp: 'Richo 10/21/2008 15:51'!
port: inputPort 
	"inputPort Range: 0-3"
	| msg |
	msg := 0 asCharacter asString , 16r10 asCharacter asString , inputPort asCharacter asString.
	self send: msg.
	^ self receiveAndCheck! !

DirectCommand subclass: #LSWrite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!LSWrite methodsFor: 'as yet unclassified' stamp: 'Richo 10/21/2008 15:51'!
port: inputPort txLength: txLength rxLength: rxLength txData: dataString 
	"inputPort Range: 0-3"
	| msg |
	msg := 128 asCharacter asString , 15 asCharacter asString , inputPort asCharacter asString , txLength asCharacter asString , rxLength asCharacter asString , dataString.
	self send: msg! !

DirectCommand subclass: #PlaySoundFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!PlaySoundFile methodsFor: 'as yet unclassified' stamp: 'Richo 9/30/2008 14:31'!
withLoop: bool fileName: aString 
".rso"
	| msg |
	msg := 128 asCharacter asString , 2 asCharacter asString
				, (bool
						ifTrue: [1 asCharacter asString]
						ifFalse: [0 asCharacter asString]) , aString , 0 asCharacter asString.
	self send: msg! !

DirectCommand subclass: #PlayTone
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!PlayTone methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 15:22'!
frequency: freq duration: milliseconds 
	| mensaje |
	mensaje := 128 asCharacter asString , 3 asCharacter asString , (freq \\ 256) asCharacter asString , (freq // 256) asCharacter asString , (milliseconds \\ 256) asCharacter asString , (milliseconds // 256) asCharacter asString.
	self send: mensaje! !

DirectCommand subclass: #ResetMotorPosition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!ResetMotorPosition methodsFor: 'as yet unclassified' stamp: 'Richo 11/27/2008 16:27'!
port: portNumber relative: aBoolean 
	| mensaje |
	mensaje := 128 asCharacter asString , 10 asCharacter asString , portNumber asCharacter asString , (aBoolean
				ifTrue: ['1']
				ifFalse: ['0']).
	self send: mensaje! !

DirectCommand subclass: #SetInputMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!SetInputMode methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 15:23'!
port: inputPort sensorType: sensorType sensorMode: sensorMode 
	"inputPort Range: 0-3"
	| msg |
	msg := 128 asCharacter asString , 5 asCharacter asString , inputPort asCharacter asString , sensorType asCharacter asString , sensorMode asCharacter asString.
	self send: msg! !

DirectCommand subclass: #SetOutputState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!SetOutputState methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 15:23'!
port: outputPort power: power mode: mode regulation: regulation turnRatio: turnRatio runState: runState tachoLimit: tachoLimit 
	| mensaje tach1 tach2 tach3 tach4 tach5 limite |
	limite := tachoLimit.
	tach1 := limite // 4294967296.
	limite := limite \\ 4294967296.
	tach2 := limite // 16777216.
	limite := limite \\ 16777216.
	tach3 := limite // 65536.
	limite := limite \\ 65536.
	tach4 := limite // 256.
	tach5 := limite \\ 256.
	mensaje := 128 asCharacter asString , 4 asCharacter asString , outputPort asCharacter asString , (power >= 0
					ifTrue: [power]
					ifFalse: [256 + power]) asCharacter asString , mode asCharacter asString , regulation asCharacter asString , (turnRatio >= 0
					ifTrue: [turnRatio]
					ifFalse: [256 + turnRatio]) asCharacter asString , runState asCharacter asString , tach1 asCharacter asString , tach2 asCharacter asString , tach3 asCharacter asString , tach4 asCharacter asString , tach5 asCharacter asString.
	self send: mensaje! !

DirectCommand subclass: #StartProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!StartProgram methodsFor: 'as yet unclassified' stamp: 'Richo 9/30/2008 14:32'!
name: fileName 
	".rxe"
	| msg |
	msg := 128 asCharacter asString , 0 asCharacter asString , fileName  , 0 asCharacter asString.
	self send: msg! !

DirectCommand subclass: #StopProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-DC'!

!StopProgram methodsFor: 'as yet unclassified' stamp: 'Richo 9/30/2008 14:32'!
name: fileName 
	".rxe"
	| msg |
	msg := 128 asCharacter asString , 1 asCharacter asString , fileName  , 0 asCharacter asString.
	self send: msg! !

Object subclass: #LegoNxt
	instanceVariableNames: 'commMode motorPorts sensorPorts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!LegoNxt commentStamp: 'Richo 11/10/2009 14:33' prior: 0!
I represent a Lego Mindstorms Nxt robot.
Below you'll find an example code:
---------------------------------------------------------------------------------------
| nxt motor sensor |
 
"Connection"
nxt := LegoNxt new.
nxt connectOnPort: 'COM6'.
nxt isConnected.
nxt disconnect. "Don't forget to disconnect me after finish using me"

"Motors"
motor := NxtMotor new.
nxt portA plug: motor.
motor power: 100.
motor brake.
nxt portA unplug.

"Sensors"
sensor := NxtSensor new.
nxt port1 plug: sensor.
sensor rawValue.
sensor normalizedValue.
sensor scaledValue.
nxt port1 unplug.

"Other stuff"
nxt getBatteryLevel.
nxt playSoundFile: 'my sound file'.
nxt playTone: 783.
nxt startProgram: 'my program file'.
nxt stopProgram: 'my program file'.

!

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/11/2009 14:10'!
commMode 
	^ commMode ! !

!LegoNxt methodsFor: 'connection' stamp: 'Richo 11/10/2009 13:49'!
connectOnPort: portName 
	commMode connectOnPort: portName! !

!LegoNxt methodsFor: 'connection' stamp: 'Richo 2/11/2009 14:09'!
disconnect
commMode disconnect! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 2/11/2009 14:10'!
getBatteryLevel
	^ commMode  getBatteryLevel! !

!LegoNxt methodsFor: 'initializing' stamp: 'Richo 2/17/2009 16:12'!
initialize
	motorPorts := Array new: 3.
	1
		to: motorPorts size
		do: [:i | motorPorts
				at: i
				put: (MotorPort on: self portNumber: i)].
	sensorPorts := Array new: 4.
	1
		to: sensorPorts size
		do: [:i | sensorPorts
				at: i
				put: (SensorPort on: self portNumber: i)].
	commMode := NxtDirectMode new! !

!LegoNxt methodsFor: 'connection' stamp: 'Richo 2/11/2009 14:10'!
isConnected
	^ commMode  isConnected! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 2/11/2009 14:10'!
playSoundFile: aString 
	commMode  playSoundFile: aString! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 2/11/2009 14:10'!
playTone
	^ commMode  playTone! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 11/11/2009 16:34'!
playTone: freqNumber 
	commMode  playTone: freqNumber rounded
! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
port1
	^ sensorPorts at: 1! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
port2
	^ sensorPorts at: 2! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
port3
	^ sensorPorts at: 3! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
port4
	^ sensorPorts at: 4! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 13:52'!
portA
^motorPorts at:1! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:05'!
portB
^motorPorts at: 2! !

!LegoNxt methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:06'!
portC
	^ motorPorts at: 3! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 2/11/2009 14:10'!
startProgram: aString 
	commMode  startProgram: aString! !

!LegoNxt methodsFor: 'actions' stamp: 'Richo 2/11/2009 14:10'!
stopProgram: aString 
	commMode  stopProgram: aString! !

Object subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Constants'!

!Mode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:11'!
brake
	^ 2! !

!Mode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:11'!
motorOn
	^ 1! !

!Mode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:11'!
regulated
	^ 4! !

Object subclass: #NxtDirectMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-CommMode'!

!NxtDirectMode commentStamp: 'Richo 2/17/2009 16:50' prior: 0!
Define el modo de comunicacin por direct commands. En realidad es abstracta y cuando le mandamos #new nos devuelve o bien una instancia de NxtDirectDllMode (si est la dll) o de NxtDirectSqueakMode (si no est la dll).!

NxtDirectMode subclass: #NxtDirectDllMode
	instanceVariableNames: 'comNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-CommMode'!

!NxtDirectDllMode commentStamp: 'Richo 2/17/2009 16:45' prior: 0!
Especializa NxtDirectMode para usar la dll!

!NxtDirectDllMode class methodsFor: 'as yet unclassified' stamp: 'Richo 2/17/2009 16:20'!
new
^self basicNew initialize! !

!NxtDirectDllMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:14'!
brakeMotorOnPort: aNumber 
	self controlConnection.
	SqueakNxtDll apiBrakeMotorOnPort: aNumber - 1 com: comNumber! !

!NxtDirectDllMode methodsFor: 'connection' stamp: 'Richo 11/10/2009 13:50'!
connectOnPort: portName
	"Windows only" 
	| portNumber |
	portNumber := (portName allButFirst: 3) asInteger.
	(SqueakNxtDll apiIsConnectedOnPort: portNumber)
		ifTrue: [^ BusyPort signal: 'Serial port ', portNumber asString, ' is busy'].
	comNumber := portNumber.
	SqueakNxtDll apiConnectOnPort: portNumber! !

!NxtDirectDllMode methodsFor: 'connection' stamp: 'Richo 3/4/2009 22:14'!
disconnect
	self controlConnection.
	SqueakNxtDll apiDisconnectOnPort: comNumber.
	comNumber := nil! !

!NxtDirectDllMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:14'!
floatMotorOnPort: aNumber 
	self controlConnection.
	SqueakNxtDll apiFloatMotorOnPort: aNumber - 1 com: comNumber! !

!NxtDirectDllMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:14'!
getPowerOnPort: aNumber 
	self controlConnection.
	^ SqueakNxtDll apiGetPowerOnPort: aNumber - 1 com: comNumber! !

!NxtDirectDllMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:14'!
getRotationOnPort: aNumber 
	self controlConnection.
	^ SqueakNxtDll apiGetRotationOnPort: aNumber - 1 com: comNumber! !

!NxtDirectDllMode methodsFor: 'sensor actions' stamp: 'Richo 3/4/2009 22:15'!
getSensorNormalizedValueOnPort: aNumber 
	self controlConnection.
	^ SqueakNxtDll apiGetSensorNormalizedValueOnPort: aNumber - 1 com: comNumber! !

!NxtDirectDllMode methodsFor: 'sensor actions' stamp: 'Richo 3/4/2009 22:15'!
getSensorRawValueOnPort: aNumber 
	self controlConnection.
	^ SqueakNxtDll apiGetSensorRawValueOnPort: aNumber - 1 com: comNumber! !

!NxtDirectDllMode methodsFor: 'sensor actions' stamp: 'Richo 3/4/2009 22:15'!
getSensorScaledValueOnPort: aNumber 
	self controlConnection.
	^ SqueakNxtDll apiGetSensorScaledValueOnPort: aNumber - 1 com: comNumber! !

!NxtDirectDllMode methodsFor: 'connection' stamp: 'Richo 2/17/2009 16:05'!
isConnected
	^ SqueakNxtDll apiIsConnectedOnPort: comNumber! !

!NxtDirectDllMode methodsFor: 'sensor connection' stamp: 'Richo 3/4/2009 22:15'!
plugSensor: aNxtSensor onPort: aNumber 
	self controlConnection.
	SqueakNxtDll
		apiPlugSensorType: aNxtSensor type
		mode: aNxtSensor mode
		onPort: aNumber - 1
		com: comNumber! !

!NxtDirectDllMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:14'!
resetMotorOnPort: portNumber relative: aBoolean 
	self controlConnection.
	self resetMotorPosition port: portNumber - 1 relative: aBoolean! !

!NxtDirectDllMode methodsFor: 'message sending' stamp: 'Richo 2/19/2009 15:59'!
send: aByteString 
	| message |
	message := aByteString size asCharacter asString , 0 asCharacter asString , aByteString.

	SqueakNxtDll
		apiSend: message
		length: message size
		com: comNumber! !

!NxtDirectDllMode methodsFor: 'sensor connection' stamp: 'Richo 3/4/2009 22:15'!
sensorTypeOnPort: aNumber 
	self controlConnection.
	^ SqueakNxtDll apiSensorTypeOnPort: aNumber - 1 com: comNumber! !

!NxtDirectDllMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:14'!
setPower: powerNumber onPort: portNumber 
	self controlConnection.
	SqueakNxtDll
		apiSetPower: powerNumber asInteger
		onPort: portNumber - 1
		com: comNumber! !

!NxtDirectDllMode methodsFor: 'sensor connection' stamp: 'Richo 3/4/2009 22:15'!
unplugSensorOnPort: aNumber 
	self controlConnection.
	SqueakNxtDll apiUnplugSensorOnPort: aNumber - 1 com: comNumber! !

!NxtDirectMode class methodsFor: 'instance creation' stamp: 'Richo 2/17/2009 16:56'!
new
^ ((FileDirectory on: SmalltalkImage current vmPath)
	fileExists: 'squeakNxt.dll')
	ifTrue: [NxtDirectDllMode new]
	ifFalse: [NxtDirectSqueakMode new]
! !

!NxtDirectMode methodsFor: 'error control' stamp: 'Richo 3/5/2009 15:45'!
controlConnection
	self isConnected
		ifFalse: [^ NotConnectedLego signal: 'The Lego Nxt must be connected to a serial port']! !

!NxtDirectMode methodsFor: 'sensor connection' stamp: 'Richo 3/4/2009 22:16'!
correctTypeOf: aNxtSensor onPort: portNumber 
	self controlConnection.
	(self sensorTypeOnPort: portNumber)
			= aNxtSensor type
		ifFalse: [self plugSensor: aNxtSensor onPort: portNumber]! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
forceError
	^ ForceError on: self! !

!NxtDirectMode methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:16'!
getBatteryLevel
self controlConnection.
	^ (GetBatteryLevel on: self) value! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
getInputValues
	^ GetInputValues on: self! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
getOutputState
	^ GetOutputState on: self! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
lsGetStatus
	^ LSGetStatus on: self! !

!NxtDirectMode methodsFor: 'sensor actions' stamp: 'Richo 3/4/2009 22:16'!
lsGetStatusOnPort: aNumber 
	self controlConnection.
	^ self lsGetStatus port: aNumber - 1! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
lsRead
	^ LSRead on: self! !

!NxtDirectMode methodsFor: 'sensor actions' stamp: 'Richo 3/4/2009 22:16'!
lsReadPort: aNumber 
	self controlConnection.
	^ self lsRead port: aNumber - 1! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
lsWrite
	^ LSWrite on: self! !

!NxtDirectMode methodsFor: 'sensor actions' stamp: 'Richo 3/4/2009 22:16'!
lsWriteOnPort: portNumber txLength: txLength rxLength: rxLength txData: dataString 
	self controlConnection.
	self lsWrite
		port: portNumber - 1
		txLength: txLength
		rxLength: rxLength
		txData: dataString! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
playSoundFile
	^ PlaySoundFile on: self! !

!NxtDirectMode methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:16'!
playSoundFile: aString 
	self controlConnection.
	self playSoundFile withLoop: false fileName: aString! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
playTone
	^ PlayTone on: self! !

!NxtDirectMode methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:16'!
playTone: freqNumber 
	self controlConnection.
	self playTone frequency: freqNumber duration: 200! !

!NxtDirectMode methodsFor: 'motor connection' stamp: 'Richo 2/17/2009 16:41'!
plugMotor: aNxtMotor onPort: aNumber 

	^ self! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
resetMotorPosition
	^ ResetMotorPosition on: self! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
setInputMode
	^ SetInputMode on: self! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
setOutputState
	^ SetOutputState on: self! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:37'!
startProgram
	^ StartProgram on: self! !

!NxtDirectMode methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:16'!
startProgram: aString 
	self controlConnection.
	self startProgram name: aString! !

!NxtDirectMode methodsFor: 'direct commands' stamp: 'Richo 2/17/2009 16:38'!
stopProgram
	^ StopProgram on: self! !

!NxtDirectMode methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:16'!
stopProgram: aString 
	self controlConnection.
	self stopProgram name: aString! !

!NxtDirectMode methodsFor: 'motor connection' stamp: 'Richo 2/17/2009 16:41'!
unplugMotorOnPort: aNumber 
	^ self! !

NxtDirectMode subclass: #NxtDirectSqueakMode
	instanceVariableNames: 'port sensorProcesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-CommMode'!

!NxtDirectSqueakMode commentStamp: 'Richo 2/17/2009 16:48' prior: 0!
Especializa NxtDirectMode para no usar la dll y hacer todo desde Squeak usando SerialPort.!

!NxtDirectSqueakMode class methodsFor: 'as yet unclassified' stamp: 'Richo 2/17/2009 16:20'!
new
	^ self basicNew initialize! !

!NxtDirectSqueakMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:17'!
brakeMotorOnPort: aNumber 
	self controlConnection.
	self setOutputState
		port: aNumber - 1
		power: 0
		mode: Mode brake + Mode motorOn
		regulation: RegulationMode regulationModeMotorSpeed
		turnRatio: 0
		runState: RunState motorRunStateRunning
		tachoLimit: 0! !

!NxtDirectSqueakMode methodsFor: 'connection' stamp: 'Richo 11/10/2009 16:56'!
connectOnPort: portName 
	"Si el puerto no se puede abrir guarda nil en la variable port, de esta
	forma podemos saber si est conectado preguntando si port es nil"

	port := SerialPort new baudRate: 9600;
				 parityType: 0;
				 dataBits: 8;
				 stopBitsType: 1.
	port := port openPort:  (('COM*' match: portName)
						ifTrue: [portName asInteger]
						ifFalse: [portName])! !

!NxtDirectSqueakMode methodsFor: 'connection' stamp: 'Richo 3/4/2009 22:17'!
disconnect
	self controlConnection.
	self stopAllMotors.
	self stopAllSensors.
	port close.
	port := nil! !

!NxtDirectSqueakMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:17'!
floatMotorOnPort: aNumber 
	self controlConnection.
	self setOutputState
		port: aNumber - 1
		power: 0
		mode: 0
		regulation: 0
		turnRatio: 0
		runState: 0
		tachoLimit: 0! !

!NxtDirectSqueakMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:17'!
getMotorValuesOnPort: aNumber 
	self controlConnection.
	^ self getOutputState port: aNumber - 1! !

!NxtDirectSqueakMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:17'!
getPowerOnPort: aNumber 
	"Sin terminar. Sorry"
	self controlConnection.
	^ 0! !

!NxtDirectSqueakMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:17'!
getRotationOnPort: aNumber 
	"Sin terminar. Sorry"
	self controlConnection.
	^ -1! !

!NxtDirectSqueakMode methodsFor: 'sensor actions' stamp: 'Richo 3/4/2009 22:17'!
getSensorNormalizedValueOnPort: aNumber 
	self controlConnection.
	^ (sensorProcesses
		select: [:each | each port = (aNumber - 1)]) anyOne normalizedValue! !

!NxtDirectSqueakMode methodsFor: 'sensor actions' stamp: 'Richo 3/4/2009 22:17'!
getSensorRawValueOnPort: aNumber 
	self controlConnection.
	^ (sensorProcesses
		select: [:each | each port = (aNumber - 1)]) anyOne rawValue! !

!NxtDirectSqueakMode methodsFor: 'sensor actions' stamp: 'Richo 3/4/2009 22:18'!
getSensorScaledValueOnPort: aNumber 
	self controlConnection.
	^ (sensorProcesses
		select: [:each | each port = (aNumber - 1)]) anyOne scaledValue! !

!NxtDirectSqueakMode methodsFor: 'initialize-release' stamp: 'Richo 2/17/2009 16:03'!
initialize
	sensorProcesses := OrderedCollection new.
! !

!NxtDirectSqueakMode methodsFor: 'connection' stamp: 'Richo 2/17/2009 16:22'!
isConnected
	^ port notNil! !

!NxtDirectSqueakMode methodsFor: 'sensor connection' stamp: 'Richo 3/4/2009 22:18'!
plugSensor: aNxtSensor onPort: aNumber 
	| portNumber |
	self controlConnection.
	portNumber := aNumber - 1.
	self unplugSensorOnPort: portNumber.
	[self setInputMode
		port: portNumber
		sensorType: aNxtSensor type
		sensorMode: aNxtSensor mode]
		on: Error
		do: [self error: 'Por qu puse #on:do: aca?'].
	sensorProcesses add: (SensorProcess
			on: self
			type: aNxtSensor type
			mode: aNxtSensor mode
			port: portNumber) start! !

!NxtDirectSqueakMode methodsFor: 'message sending' stamp: 'Richo 2/17/2009 16:44'!
receive
	^ port readByteArray! !

!NxtDirectSqueakMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:17'!
resetMotorOnPort: portNumber relative: aBoolean 
	self controlConnection.
	self resetMotorPosition port: portNumber - 1 relative: aBoolean! !

!NxtDirectSqueakMode methodsFor: 'message sending' stamp: 'Richo 3/4/2009 22:17'!
send: aByteString 
	self controlConnection.
	port nextPutAll: aByteString size asCharacter asString , 0 asCharacter asString , aByteString! !

!NxtDirectSqueakMode methodsFor: 'sensor connection' stamp: 'Richo 3/4/2009 22:18'!
sensorTypeOnPort: aNumber 
	| l |
	self controlConnection.
	l := sensorProcesses
				select: [:each | each port = (aNumber - 1)].
	l isEmpty
		ifTrue: [^ SensorType noSensor].
	^ l anyOne type! !

!NxtDirectSqueakMode methodsFor: 'motor actions' stamp: 'Richo 3/4/2009 22:17'!
setPower: powerNumber onPort: portNumber 
	self controlConnection.
	self setOutputState
		port: portNumber - 1
		power: powerNumber
		mode: Mode regulated + Mode motorOn
		regulation: RegulationMode regulationModeMotorSpeed
		turnRatio: 0
		runState: RunState motorRunStateRunning
		tachoLimit: 0! !

!NxtDirectSqueakMode methodsFor: 'initialize-release' stamp: 'Richo 2/17/2009 16:03'!
stopAllMotors
	1
		to: 3
		do: [:i | self unplugMotorOnPort: i]! !

!NxtDirectSqueakMode methodsFor: 'initialize-release' stamp: 'Richo 2/17/2009 16:40'!
stopAllSensors

	1
		to: 4
		do: [:i | self unplugSensorOnPort: i]! !

!NxtDirectSqueakMode methodsFor: 'sensor connection' stamp: 'Richo 3/4/2009 22:18'!
unplugSensorOnPort: aNumber 
	| portNumber |
	self controlConnection.
	portNumber := aNumber - 1.
	[self setInputMode
		port: portNumber
		sensorType: SensorType noSensor
		sensorMode: SensorMode rawmode]
		on: Error
		do: [].
	sensorProcesses
		select: [:each | each port = portNumber]
		thenDo: [:each | each stop].
	sensorProcesses
		removeAllSuchThat: [:each | each port = portNumber]! !

Object subclass: #NxtPluggableDevice
	instanceVariableNames: 'port nxt portNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!NxtPluggableDevice commentStamp: 'Richo 12/3/2008 00:20' prior: 0!
Es una clase abstracta. Representa un dispositivo que puede conectarse al LegoNxt (como motores o sensores).

Protocolo de conexin:
#connectToNxt:onPort: - Intenta conectarse a un nxt en un puerto dado.
#disconnect - Se desconecta del nxt.
En el comentario de LegoNxt se explica otro protocolo para conectar dispositivos, stos mtodos son una forma alternativa que permiten crear el dispositivo primero y decirle a qu nxt conectarse. Las formas de conexin no son excluyentes una de otra, pero se recomienda usar la que est explicada en el comentario de LegoNxt.
!

NxtPluggableDevice subclass: #NxtMotor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!NxtMotor commentStamp: 'Richo 12/3/2008 00:22' prior: 0!
Representa un motor que puede conectarse al LegoNxt.

Protocolo:
#brake - Frena el motor de golpe.
#float - Frena el motor suavemente manteniendo la inercia.
#power - Devuelve la velocidad actual del motor.
#power: - Setea la velocidad del motor.
#resetRelative: - ?
#rotation - Devuelve la rotacin del robot (todava no se como interpretar esta informacin)
!

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
brake
	self controlPlugging.
	port brake! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
float
		self controlPlugging.
	port float! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
power
		self controlPlugging.
	^ port getPower! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 11/11/2009 15:51'!
power: aNumber 
	"Motor | Port
	A | 0
	B | 1
	C | 2"
	"Power range: -100 100"
		self controlPlugging.
	port setPower: aNumber rounded! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
resetRelative: aBoolean 
	self controlPlugging.
	port resetRelative: aBoolean! !

!NxtMotor methodsFor: 'actions' stamp: 'Richo 3/4/2009 22:22'!
rotation
	self controlPlugging.
	^ port getRotation! !

!NxtPluggableDevice methodsFor: 'error control' stamp: 'Richo 3/5/2009 16:17'!
controlPlugging
	self isPlugged
		ifFalse: [^ UnpluggedDevice signal: 'The ', self asString , ' must be plugged']! !

!NxtPluggableDevice methodsFor: 'plugging' stamp: 'Richo 2/16/2009 14:14'!
isPlugged
	^ port notNil! !

!NxtPluggableDevice methodsFor: 'plugging' stamp: 'Richo 3/5/2009 16:06'!
plugOn: aPort 
	self isPlugged
		ifTrue: [^ AlreadyPluggedDevice signal: 'The ', self asString, ' is already plugged'].
	thisContext client == aPort
		ifFalse: [aPort plug: self].
	port := aPort! !

!NxtPluggableDevice methodsFor: 'accessing' stamp: 'Richo 2/16/2009 14:15'!
port
^port! !

!NxtPluggableDevice methodsFor: 'printing' stamp: 'Richo 3/5/2009 16:05'!
printOn: aStream 
	aStream nextPutAll: self class asString! !

!NxtPluggableDevice methodsFor: 'plugging' stamp: 'Richo 3/5/2009 16:20'!
unplug
	"La conexin debe ser bidireccional"
	self isPlugged
		ifFalse: [^ UnpluggedDevice signal: 'The ', self asString , ' is already unplugged'].
	thisContext client = port
		ifFalse: [port unplug].
	port := nil! !

NxtPluggableDevice subclass: #NxtSensor
	instanceVariableNames: 'type mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!NxtSensor commentStamp: 'Richo 12/3/2008 00:29' prior: 0!
Es una clase abstracta. Representa un sensor que puede conectarse a un LegoNxt. Define toda la implementacin necesaria para comunicarse con el nxt. Sus subclases tienen la nica responsabilidad de definir el comportamiento especfico de cada tipo de sensor as como de sus datos internos (tipo y modo).
Todo sensor tiene un tipo (revisar SensorType) y un modo (revisar SensorMode).

Protocolo:
#rawValue - Devuelve los valores del sensor en crudo.
#normalizedValue - Devuelve los valores del sensor en un rango de 0 a 1023 (depende del tipo).
#scaledValue - Devuelve los valores del sensor en un rango de 0 a 100 (depende del modo).!

NxtSensor subclass: #LightSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!LightSensor commentStamp: 'Richo 12/3/2008 00:31' prior: 0!
Representa un sensor de luz. Puede setearse como activo (prende la lucecita roja y detecta la luz reflejada) o inactivo (no la prende y detecta la luz del ambiente).!

!LightSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:37'!
initialize
	self setInactive.
	mode:= SensorMode pctfullscalemode! !

!LightSensor methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 15:20'!
isActive
^self type = SensorType lightActive ! !

!LightSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
setActive
type := SensorType lightActive! !

!LightSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
setInactive
type := SensorType lightInactive! !

!NxtSensor methodsFor: 'accessing' stamp: 'Richo 10/17/2008 15:35'!
mode
	^ mode! !

!NxtSensor methodsFor: 'accessing-value' stamp: 'Richo 3/5/2009 15:44'!
normalizedValue

	self controlPlugging.
	port correctTypeOf: self.
	^ port getSensorNormalizedValue! !

!NxtSensor methodsFor: 'accessing-value' stamp: 'Richo 3/5/2009 15:44'!
rawValue

	self controlPlugging.
	port correctTypeOf: self.
	^ port getSensorRawValue! !

!NxtSensor methodsFor: 'accessing-value' stamp: 'Richo 3/5/2009 15:44'!
scaledValue
	self controlPlugging.
	port correctTypeOf: self.
	^ port getSensorScaledValue! !

!NxtSensor methodsFor: 'accessing' stamp: 'Richo 9/30/2008 16:15'!
type 
^type! !

NxtSensor subclass: #SoundSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!SoundSensor commentStamp: 'Richo 12/3/2008 00:29' prior: 0!
Representa un sensor de Sonido. Puede setearse como audible o inaudible.!

!SoundSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:37'!
initialize
	self setInaudible.
	mode:= SensorMode pctfullscalemode! !

!SoundSensor methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:16'!
isAudible
^self type = SensorType soundDba ! !

!SoundSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
setAudible
type :=  SensorType soundDba! !

!SoundSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
setInaudible
type := SensorType soundDb! !

NxtSensor subclass: #SwitchSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!SwitchSensor commentStamp: 'Richo 12/3/2008 00:30' prior: 0!
Representa un sensor de tacto.!

!SwitchSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
initialize
type :=  SensorType switch.
	mode := SensorMode booleanmode! !

NxtSensor subclass: #UltrasonicSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!UltrasonicSensor commentStamp: 'Richo 12/3/2008 00:30' prior: 0!
Representa un sensor de ultrasonido.!

!UltrasonicSensor methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2009 13:38'!
initialize
	"When wanting to use the ultrasonic sensor, the sensor type should be
	set to LowSpeed_9V (the ultrasonic sensors is a digital sensor which
	need Lowspeed(I2C) communication and it also needs 9V. Sensor mode is
	not used when a digital sensor is used therefore this can be set to 0. If
	you want to use the ultrasonic sensor using direct command you first
	need to setup the sensor type correctly and the make a LSWRITE
	command and thereafter waiting for the communication to finish using
	the LSGETSTATUS and then finally make a LSREAD command."
type :=  SensorType lowspeed9V.
	mode := SensorMode rawmode! !

Object subclass: #Port
	instanceVariableNames: 'nxt pluggedDevice portNumber number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

Port subclass: #MotorPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 2/16/2009 15:27'!
brake
	nxt commMode brakeMotorOnPort: portNumber! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 2/16/2009 16:34'!
float

	nxt commMode floatMotorOnPort: portNumber! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 2/16/2009 16:12'!
getPower
^nxt commMode getPowerOnPort: portNumber! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 2/16/2009 15:40'!
getRotation
^nxt commMode getRotationOnPort: portNumber! !

!MotorPort methodsFor: 'printing' stamp: 'Richo 3/5/2009 15:52'!
printOn: aStream 

	portNumber = 1
		ifTrue: [aStream nextPutAll: 'Port A'. ^self].
	portNumber = 2
		ifTrue: [aStream nextPutAll: 'Port B'. ^self].
	portNumber = 3
		ifTrue: [aStream nextPutAll: 'Port C'.^self].
	aStream nextPutAll: 'Invalid port'
! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 2/16/2009 15:39'!
resetRelative: aBoolean
nxt commMode resetMotorOnPort: portNumber relative: aBoolean! !

!MotorPort methodsFor: 'plugging' stamp: 'Richo 2/16/2009 15:27'!
sendPlugCommandFor: aNxtMotor 
	nxt commMode plugMotor: aNxtMotor onPort: portNumber! !

!MotorPort methodsFor: 'plugging' stamp: 'Richo 2/16/2009 15:30'!
sendUnplugCommand
	nxt commMode unplugMotorOnPort: portNumber! !

!MotorPort methodsFor: 'motor actions' stamp: 'Richo 2/16/2009 15:27'!
setPower: aNumber 
	nxt commMode setPower: aNumber onPort: portNumber! !

!Port class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:01'!
new
self shouldNotImplement! !

!Port class methodsFor: 'instance creation' stamp: 'Richo 2/16/2009 15:27'!
on: aLegoNxt portNumber: aNumber 
	^ self basicNew setNxt: aLegoNxt portNumber: aNumber! !

!Port methodsFor: 'testing' stamp: 'Richo 2/16/2009 14:36'!
isBusy
^pluggedDevice notNil! !

!Port methodsFor: 'plugging' stamp: 'Richo 3/5/2009 15:46'!
plug: aNxtPluggableDevice 
	self isBusy
		ifTrue: [^ BusyPort signal: self asString , ' is busy'].
	aNxtPluggableDevice plugOn: self.
	pluggedDevice := aNxtPluggableDevice.
	self sendPlugCommandFor: aNxtPluggableDevice! !

!Port methodsFor: 'accessing' stamp: 'Richo 3/5/2009 16:01'!
pluggedDevice
	pluggedDevice isNil
		ifTrue: [^ UnpluggedDevice signal: 'Nothing is plugged in ', self asString].
	^ pluggedDevice! !

!Port methodsFor: 'accessing' stamp: 'Richo 2/16/2009 15:51'!
portNumber
^portNumber! !

!Port methodsFor: 'plugging' stamp: 'Richo 2/16/2009 15:24'!
sendPlugCommandFor: aNxtPluggableDevice 
	self subclassResponsibility! !

!Port methodsFor: 'plugging' stamp: 'Richo 2/16/2009 15:24'!
sendUnplugCommand
	self subclassResponsibility! !

!Port methodsFor: 'private' stamp: 'Richo 2/16/2009 15:27'!
setNxt: aLegoNxt portNumber: aNumber 
	nxt := aLegoNxt.
	portNumber := aNumber! !

!Port methodsFor: 'plugging' stamp: 'Richo 2/16/2009 15:23'!
unplug
	self pluggedDevice unplug.
	pluggedDevice := nil.
	self sendUnplugCommand! !

Port subclass: #SensorPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Model'!

!SensorPort methodsFor: 'sensor actions' stamp: 'Richo 2/16/2009 17:33'!
correctTypeOf: aNxtSensor 
	[nxt commMode correctTypeOf: aNxtSensor onPort: portNumber]
on: NotConnectedLego do: []! !

!SensorPort methodsFor: 'sensor actions' stamp: 'Richo 2/16/2009 15:36'!
getSensorNormalizedValue
^nxt commMode getSensorNormalizedValueOnPort: portNumber! !

!SensorPort methodsFor: 'sensor actions' stamp: 'Richo 2/16/2009 15:35'!
getSensorRawValue
^nxt commMode getSensorRawValueOnPort: portNumber! !

!SensorPort methodsFor: 'sensor actions' stamp: 'Richo 2/16/2009 15:37'!
getSensorScaledValue
^nxt commMode getSensorScaledValueOnPort: portNumber! !

!SensorPort methodsFor: 'printing' stamp: 'Richo 3/5/2009 15:52'!
printOn: aStream 
	(portNumber between: 1 and: 4)
		ifTrue: [aStream nextPutAll: 'Port ' , portNumber asString]
		ifFalse: [
	aStream nextPutAll: 'Invalid port']! !

!SensorPort methodsFor: 'plugging' stamp: 'Richo 2/16/2009 17:30'!
sendPlugCommandFor: aNxtSensor 
	[nxt commMode plugSensor: aNxtSensor onPort: portNumber] on: NotConnectedLego do: []! !

!SensorPort methodsFor: 'plugging' stamp: 'Richo 2/16/2009 17:30'!
sendUnplugCommand
[	nxt commMode unplugSensorOnPort: portNumber] on: NotConnectedLego do: []! !

Object subclass: #RegulationMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Constants'!

!RegulationMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
regulationModeIdle
	^ 0! !

!RegulationMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
regulationModeMotorSpeed
	^ 1! !

!RegulationMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
regulationModeMotorSync
	^ 2! !

Object subclass: #RunState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Constants'!

!RunState class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
motorRunStateIdle
	^ 0! !

!RunState class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
motorRunStateRampdown
	^ 64! !

!RunState class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
motorRunStateRampup
	^ 16! !

!RunState class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 13:59'!
motorRunStateRunning
	^ 32! !

Object subclass: #SensorMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Constants'!

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:22'!
anglestepsmode
	^ 16rE0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:21'!
booleanmode
	^ 16r20! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:22'!
celsiusmode
	^ 16rA0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:22'!
fahrenheitmode
	^ 16rC0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:23'!
modemask
	^ 16rE0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 15:35'!
pctfullscalemode
"Porcentaje"
	^ 128! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:21'!
periodcountermode
	^ 16r60! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 15:36'!
rawmode
"De 0 a 1023"
	^ 0! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:23'!
slopemask
	^ 16r1F! !

!SensorMode class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:21'!
transitioncntmode
	^ 16r40! !

Object subclass: #SensorProcess
	instanceVariableNames: 'commMode type mode port process timesNeeded rawValue normalizedValue scaledValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-CommMode'!

!SensorProcess class methodsFor: 'as yet unclassified' stamp: 'Richo 12/2/2008 16:18'!
on: commMode type: sensorType mode: sensorMode port: portNumber 
	^ (self basicNew
	commMode: commMode;
	 type: sensorType;
		 mode: sensorMode;
		 port: portNumber) initialize! !

!SensorProcess methodsFor: 'process' stamp: 'Richo 12/2/2008 16:30'!
actualizeRegularSensorValues
	| sensorValues |
	sensorValues := commMode getInputValues port: port.
[	rawValue := (sensorValues at: 11) asInteger + ((sensorValues at: 12) asInteger * 256).
	normalizedValue := (sensorValues at: 13) asInteger + ((sensorValues at: 14) asInteger * 256).
	scaledValue := (sensorValues at: 15) asInteger + ((sensorValues at: 16) asInteger * 256)]
on:Error do: ["Podran haber llegado valores vacos"]! !

!SensorProcess methodsFor: 'process' stamp: 'Richo 12/3/2008 14:13'!
actualizeUltrasonicSensorValues
	| keepGoing sensorValues |
	commMode
		lsWriteOnPort: port + 1
		txLength: 2
		rxLength: 1
		txData: 2 asCharacter asString , 66 asCharacter asString.
	[keepGoing := false.
	[commMode lsGetStatusOnPort: port + 1]
		on: Error
		do: [keepGoing := true]]
		doWhileTrue: [keepGoing].
	sensorValues := commMode lsReadPort: port + 1.
[	rawValue := (sensorValues at: 7) asInteger]
on: Error do: ["sensorValues podra llegar vaco o incorrecto"]! !

!SensorProcess methodsFor: 'process' stamp: 'Richo 12/2/2008 16:10'!
actualizeValues
timesNeeded <= 0
ifTrue: [^self].
type = SensorType lowspeed9V 
ifTrue: [self actualizeUltrasonicSensorValues]
ifFalse: [self actualizeRegularSensorValues]
.self decreaseTimesNeeded! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 16:18'!
commMode: aNxtDirectMode
commMode := aNxtDirectMode! !

!SensorProcess methodsFor: 'process' stamp: 'Richo 12/2/2008 16:13'!
decreaseTimesNeeded
timesNeeded :=timesNeeded - 1 ! !

!SensorProcess methodsFor: 'process' stamp: 'Richo 12/2/2008 16:13'!
increaseTimesNeeded
timesNeeded := timesNeeded + 2 min: 10! !

!SensorProcess methodsFor: 'initialize-release' stamp: 'Richo 12/2/2008 16:21'!
initialize
	timesNeeded := rawValue:= normalizedValue := scaledValue:= 0.
! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 15:58'!
mode
	^ mode! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 15:58'!
mode: anObject
	mode := anObject! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 16:15'!
normalizedValue
	self increaseTimesNeeded.
	^ normalizedValue! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 15:58'!
port
	^ port! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 15:58'!
port: anObject
	port := anObject! !

!SensorProcess methodsFor: 'printing' stamp: 'Richo 12/2/2008 16:38'!
printOn: aStream
super printOn: aStream.
aStream nextPutAll: '(port: ', port asString, ')'.
! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 16:15'!
rawValue
self increaseTimesNeeded . ^rawValue! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 16:15'!
scaledValue
	self increaseTimesNeeded.
	^ scaledValue! !

!SensorProcess methodsFor: 'process' stamp: 'Richo 11/10/2009 13:16'!
start

	self stop.
	process := [	| delay |
				delay := (Delay forMilliseconds: 70).
				[self actualizeValues.
				delay wait] repeat]
				forkNamed: self asString! !

!SensorProcess methodsFor: 'process' stamp: 'Richo 12/2/2008 16:16'!
stop
process ifNotNilDo: [:p| p terminate]! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 15:58'!
type
	^ type! !

!SensorProcess methodsFor: 'accessing' stamp: 'Richo 12/2/2008 15:58'!
type: anObject
	type := anObject! !

Object subclass: #SensorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Constants'!

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
angle
	^ 4! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
custom
	^ 9! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
lightActive
	^ 5! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
lightInactive
	^ 6! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
lowspeed
	^ 16rA! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
lowspeed9V
	^ 11! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
noOfSensorTypes
	^ 12! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
noSensor
	^ 0! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
reflection
	^ 3! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:16'!
soundDb
^7! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 10/17/2008 17:00'!
soundDba
"decibeles audibles"
	^ 8! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
switch
	^ 1! !

!SensorType class methodsFor: 'as yet unclassified' stamp: 'Richo 9/29/2008 14:12'!
temperature
	^ 2! !

Object subclass: #SqueakNxtDll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-CommMode'!

!SqueakNxtDll class methodsFor: 'primitives-motor actions' stamp: 'Richo 2/17/2009 16:00'!
apiBrakeMotorOnPort: aNumber com: anotherNumber 
	<apicall: void 'brakeMotor' (short short) module: 'squeakNxt.dll'>
	^self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-connection' stamp: 'Richo 2/17/2009 15:59'!
apiConnectOnPort: aNumber 

	<apicall: void 'connect' (short) module: 'squeakNxt.dll'>
	^self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-connection' stamp: 'Richo 2/17/2009 15:59'!
apiDisconnectOnPort: aNumber 
	<apicall: void 'disconnect' (short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-motor actions' stamp: 'Richo 2/17/2009 16:00'!
apiFloatMotorOnPort: aNumber com: anotherNumber 
	<apicall: void 'floatMotor' (short short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-motor actions' stamp: 'Richo 2/17/2009 16:00'!
apiGetPowerOnPort: portNumber com: aNumber 
	<apicall: short 'getPower' (short short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-motor actions' stamp: 'Richo 2/17/2009 16:00'!
apiGetRotationOnPort: portNumber com: aNumber 
	<apicall: long 'getRotation' (short short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-sensor actions' stamp: 'Richo 2/17/2009 16:01'!
apiGetSensorNormalizedValueOnPort: aNumber com: anotherNumber 
	<apicall: short 'getSensorNormalizedValue' (short short) module: 'squeakNxt.dll'>
	^self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-sensor actions' stamp: 'Richo 2/17/2009 16:01'!
apiGetSensorRawValueOnPort: aNumber com: anotherNumber 
	<apicall: short 'getSensorRawValue' (short short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-sensor actions' stamp: 'Richo 2/17/2009 16:02'!
apiGetSensorScaledValueOnPort: aNumber com: anotherNumber 
	<apicall: short 'getSensorScaledValue' (short short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-connection' stamp: 'Richo 2/17/2009 15:59'!
apiIsConnectedOnPort: aNumber 
	<apicall: bool 'isConnected' (short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-sensor connection' stamp: 'Richo 2/17/2009 16:02'!
apiPlugSensorType: sensorType mode: sensorMode onPort: aNumber com: anotherNumber 
	<apicall: void 'plugSensor' (short short short short) module: 'squeakNxt.dll'>
	^self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-sending' stamp: 'Richo 2/17/2009 15:59'!
apiSend: aByteString length: aNumber com: anotherNumber 
	<apicall: void 'send' (char* short short) module: 'squeakNxt.dll'>
	^self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-sensor connection' stamp: 'Richo 2/17/2009 16:02'!
apiSensorTypeOnPort: aNumber com: anotherNumber 
	<apicall: short 'getSensorType' (short short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-motor actions' stamp: 'Richo 2/17/2009 16:01'!
apiSetPower: powerNumber onPort: portNumber com: aNumber 
	<apicall: void 'setPower' (short short short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

!SqueakNxtDll class methodsFor: 'primitives-sensor connection' stamp: 'Richo 2/17/2009 16:02'!
apiUnplugSensorOnPort: aNumber com: anotherNumber 
	<apicall: void 'unplugSensor' (short short) module: 'squeakNxt.dll'>
	^ self externalCallFailed! !

Object subclass: #UpdateFlags
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-Constants'!

!UpdateFlags commentStamp: 'Richo 10/28/2008 16:09' prior: 0!
UF_UPDATE_MODE (0x01), UF_UPDATE_SPEED (0x02),
UF_UPDATE_TACHO_LIMIT (0x04), UF_UPDATE_RESET_COUNT (0x08),
UF_UPDATE_PID_VALUES (0x10), UF_UPDATE_RESET_BLOCK_COUNT
(0x20), UF_UPDATE_RESET_ROTATION_COUNT (0x40),
UF_PENDING_UPDATES (0x80)!

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:09'!
mode
^1! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:11'!
pendingUpdates
^128
! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:10'!
pidValues
^16! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:10'!
resetBlockCount
^32! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:10'!
resetCount
^8! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:10'!
resetRotationCount
^64! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:09'!
speed
^2! !

!UpdateFlags class methodsFor: 'as yet unclassified' stamp: 'Richo 10/28/2008 16:09'!
tachoLimit
^4! !
